## pybind11 2.6.2

=== tests/requirements.txt ===
--extra-index-url https://antocuni.github.io/pypy-wheels/manylinux2010/
numpy==1.16.6; python_version<"3.6" and sys_platform!="win32"
numpy==1.18.0; platform_python_implementation=="PyPy" and sys_platform=="darwin" and python_version>="3.6"
numpy==1.19.3; (platform_python_implementation!="PyPy" or sys_platform=="linux") and python_version>="3.6" and python_version<"3.10"
pytest==4.6.9; python_version<"3.5"
pytest==6.1.2; python_version=="3.5"
pytest==6.2.1; python_version>="3.6"
pytest-timeout
scipy==1.2.3; (platform_python_implementation!="PyPy" or sys_platform=="linux") and python_version<"3.6"
scipy==1.5.4; (platform_python_implementation!="PyPy" or sys_platform=="linux") and python_version>="3.6" and python_version<"3.10"

=== tests/test_cmake_build/installed_function/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)
project(test_installed_module CXX)

# The `cmake_minimum_required(VERSION 3.4...3.18)` syntax does not work with
# some versions of VS that have a patched CMake 3.11. This forces us to emulate
# the behavior using the following workaround:
if(${CMAKE_VERSION} VERSION_LESS 3.18)
  cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
else()
  cmake_policy(VERSION 3.18)
endif()

project(test_installed_function CXX)

find_package(pybind11 CONFIG REQUIRED)
message(
  STATUS "Found pybind11 v${pybind11_VERSION} ${pybind11_VERSION_TYPE}: ${pybind11_INCLUDE_DIRS}")

pybind11_add_module(test_installed_function SHARED NO_EXTRAS ../main.cpp)
set_target_properties(test_installed_function PROPERTIES OUTPUT_NAME test_cmake_build)

if(DEFINED Python_EXECUTABLE)
  set(_Python_EXECUTABLE "${Python_EXECUTABLE}")
elseif(DEFINED PYTHON_EXECUTABLE)
  set(_Python_EXECUTABLE "${PYTHON_EXECUTABLE}")
else()
  message(FATAL_ERROR "No Python executable defined (should not be possible at this stage)")
endif()

add_custom_target(
  check_installed_function
  ${CMAKE_COMMAND}
  -E
  env
  PYTHONPATH=$<TARGET_FILE_DIR:test_installed_function>
  ${_Python_EXECUTABLE}
  ${PROJECT_SOURCE_DIR}/../test.py
  ${PROJECT_NAME})

=== tests/test_cmake_build/subdirectory_target/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)

# The `cmake_minimum_required(VERSION 3.4...3.18)` syntax does not work with
# some versions of VS that have a patched CMake 3.11. This forces us to emulate
# the behavior using the following workaround:
if(${CMAKE_VERSION} VERSION_LESS 3.18)
  cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
else()
  cmake_policy(VERSION 3.18)
endif()

project(test_subdirectory_target CXX)

add_subdirectory("${pybind11_SOURCE_DIR}" pybind11)

add_library(test_subdirectory_target MODULE ../main.cpp)
set_target_properties(test_subdirectory_target PROPERTIES OUTPUT_NAME test_cmake_build)

target_link_libraries(test_subdirectory_target PRIVATE pybind11::module)

# Make sure result is, for example, test_installed_target.so, not libtest_installed_target.dylib
pybind11_extension(test_subdirectory_target)

if(DEFINED Python_EXECUTABLE)
  set(_Python_EXECUTABLE "${Python_EXECUTABLE}")
elseif(DEFINED PYTHON_EXECUTABLE)
  set(_Python_EXECUTABLE "${PYTHON_EXECUTABLE}")
else()
  message(FATAL_ERROR "No Python executable defined (should not be possible at this stage)")
endif()

add_custom_target(
  check_subdirectory_target
  ${CMAKE_COMMAND}
  -E
  env
  PYTHONPATH=$<TARGET_FILE_DIR:test_subdirectory_target>
  ${_Python_EXECUTABLE}
  ${PROJECT_SOURCE_DIR}/../test.py
  ${PROJECT_NAME})

=== debian/changelog ===
pybind11 (2.6.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
    - Build-Depends: cmake (>= 3.18~), ninja-build, python3-wheel
  * refresh predownloaded debian/images for privacy protection using
    debian/get_images.sh

 -- Drew Parsons <dparsons@debian.org>  Sat, 30 Jan 2021 23:55:39 +0100

pybind11 (2.6.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Standards-Version: 4.5.1

 -- Drew Parsons <dparsons@debian.org>  Thu, 19 Nov 2020 01:28:13 +0800

pybind11 (2.6.0-2) unstable; urgency=medium

  * Team upload.
  * update debian patch test_cmake_pyversion.patch to process
    PYVERSION to find python before using PYTHON_VERSION.
    Otherwise test_async is skipped. Closes: #973794.
  * use help2man to generate a manpage for pybind11-config

 -- Drew Parsons <dparsons@debian.org>  Fri, 06 Nov 2020 18:09:24 +0800

pybind11 (2.6.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * add debian patches
    - skip_sphinxcontrib_doc.patch removes sphinxcontrib
      modules rsvgconverter and moderncmakedomain for doc build, since
      they are not yet packaged.
    - test_cmake_pyversion.patch configures ./tests for specific python
      version if PYVERSION is defined for cmake.
      Applied in debian/tests. Closes: #973012, #973295.
  * To avoid privacy breaches, predownload badge image files in docs,
    store in debian/images and install in html/_images.

 -- Drew Parsons <dparsons@debian.org>  Thu, 29 Oct 2020 03:44:25 +0800

=== debian/control ===
Source: pybind11
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake (>= 3.18~),
               dpkg-dev (>= 1.17.14),
               dh-python,
               libboost-dev (>= 1.56) <!nocheck>,
               libeigen3-dev <!nocheck>,
               ninja-build,
               python3-all,
               python3-breathe <!nodoc>,
               python3-dev <!nocheck>,
               python3-numpy <!nocheck>,
               python3-pytest <!nocheck>,
               python3-scipy <!nocheck>,
               python3-setuptools,
               python3-sphinx <!nodoc>,
               python3-sphinx-rtd-theme <!nodoc>,
               python3-wheel,
               sphinx-common
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/science-team/pybind11
Vcs-Git: https://salsa.debian.org/science-team/pybind11.git
Homepage: https://github.com/pybind/pybind11

Package: pybind11-dev
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: ${misc:Depends}
Recommends: libeigen3-dev
Suggests: pybind11-doc <!nodoc>
Description: seamless operability between C++11 and Python
 pybind11 is a lightweight header library that exposes C++ types in
 Python and vice versa, mainly to create Python bindings of existing C++
 code. Its goals and syntax are similar to the excellent Boost.Python
 library by David Abrahams: to minimize boilerplate code in traditional
 extension modules by inferring type information using compile-time
 introspection.
 .
 This package provides the header-only library.

Package: pybind11-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         ${sphinxdoc:Depends}
Built-Using: ${sphinxdoc:Built-Using}
Description: documentation for pybind11
 pybind11 is a lightweight header library that exposes C++ types in
 Python and vice versa, mainly to create Python bindings of existing C++
 code. Its goals and syntax are similar to the excellent Boost.Python
 library by David Abrahams: to minimize boilerplate code in traditional
 extension modules by inferring type information using compile-time
 introspection.
 .
 This package provides the documentation.
Build-Profiles: <!nodoc>

Package: python3-pybind11
Architecture: all
Multi-Arch: foreign
Section: python
Depends: ${misc:Depends},
         ${python3:Depends},
         pybind11-dev (= ${binary:Version})
Recommends: python3-numpy
Description: pybind11 helper module for Python 3
 pybind11 is a lightweight header library that exposes C++ types in
 Python and vice versa, mainly to create Python bindings of existing C++
 code. Its goals and syntax are similar to the excellent Boost.Python
 library by David Abrahams: to minimize boilerplate code in traditional
 extension modules by inferring type information using compile-time
 introspection.
 .
 This package provides pybind11 for Python 3.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Prevent install of headers by setup.py.
export PYBIND11_USE_CMAKE=1

export PYBUILD_NAME=pybind11

CONFIGURE_ARGS=-DPYBIND11_INSTALL:BOOL=ON
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
CONFIGURE_ARGS+=-DPYBIND11_TEST:BOOL=ON \
	-DPYTHON_EXECUTABLE:FILEPATH=/usr/bin/$(shell py3versions -d)
else
CONFIGURE_ARGS+=-DPYBIND11_TEST:BOOL=OFF
endif

%:
	dh $@ --with python3,sphinxdoc --buildsystem=cmake

override_dh_auto_clean:
	dh_auto_clean
	dh_auto_clean --buildsystem=pybuild
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	$(MAKE) -C docs clean
endif

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIGURE_ARGS)
	dh_auto_configure --buildsystem=pybuild

override_dh_auto_build: export http_proxy=127.0.0.1:9
override_dh_auto_build: export https_proxy=127.0.0.1:9
override_dh_auto_build:
	dh_auto_build
	dh_auto_build --buildsystem=pybuild
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	$(MAKE) -C docs html
endif

override_dh_auto_install:
	dh_auto_install
	dh_auto_install --buildsystem=pybuild

override_dh_installchangelogs:
	dh_installchangelogs docs/changelog.rst

override_dh_installdocs:
	dh_installdocs
	cp debian/images/* debian/pybind11-doc/usr/share/doc/pybind11-doc/html/_images
	sed "s|src=\"https://github.com/pybind/pybind11/raw/master/docs/pybind11-logo.png|src=\"_images/pybind11-logo.png|g" -i debian/pybind11-doc/usr/share/doc/pybind11-doc/html/*.html
	sed "s|src=\"https://ci.appveyor.com/api/projects/status/riaj54pn4h08xy40?svg=true|src=\"_images/build_passing_riaj54pn4h08xy40.svg|g" -i debian/pybind11-doc/usr/share/doc/pybind11-doc/html/*.html
	sed "s|src=\"https://github.com/pybind/pybind11/workflows/CI/badge.svg|src=\"_images/badge.svg|g" -i debian/pybind11-doc/usr/share/doc/pybind11-doc/html/*.html
	sed "s|src=\"https://img.shields.io/gitter/room/gitterHQ/gitter.svg|src=\"_images/gitter.svg|g" -i debian/pybind11-doc/usr/share/doc/pybind11-doc/html/*.html
	sed "s|src=\"https://readthedocs.org/projects/pybind11/badge?version=latest|src=\"_images/docspassing.svg|g" -i debian/pybind11-doc/usr/share/doc/pybind11-doc/html/*.html
	sed "s|src=\"https://img.shields.io/badge/docs-stable-blue|src=\"_images/docs-stable.svg|g" -i debian/pybind11-doc/usr/share/doc/pybind11-doc/html/*.html
	sed "s|src=\"https://img.shields.io/conda/vn/conda-forge/pybind11.svg|src=\"_images/pybind11_conda.svg|g" -i debian/pybind11-doc/usr/share/doc/pybind11-doc/html/*.html
	sed "s|src=\"https://img.shields.io/pypi/v/pybind11.svg|src=\"_images/pybind11_pypi.svg|g" -i debian/pybind11-doc/usr/share/doc/pybind11-doc/html/*.html
	sed "s|src=\"https://img.shields.io/pypi/pyversions/pybind11.svg|src=\"_images/pybind11_pyversions.svg|g" -i debian/pybind11-doc/usr/share/doc/pybind11-doc/html/*.html
	sed "s|src=\"https://repology.org/badge/latest-versions/python:pybind11.svg|src=\"_images/pybind11_lastest.svg|g" -i debian/pybind11-doc/usr/share/doc/pybind11-doc/html/*.html

get-orig-source:
	uscan --download-current-version --force-download --no-symlink

=== debian/tests/control ===
Test-Command: set -e
 ; cp debian/tests/example/* "$AUTOPKGTEST_TMP"
 ; for py in $(py3versions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with $py:"
 ; CC=gcc CXX=g++ cmake -DPYTHON_EXECUTABLE=/usr/bin/$py .
 ; cmake --build .
 ; $py -c "import example; assert(example.add(1, 2) == 3)"
 ; done
Depends: cmake, g++, pybind11-dev, python3-all-dev
Restrictions: allow-stderr

Test-Command: set -e
 ; cp debian/tests/example/* "$AUTOPKGTEST_TMP"
 ; for py in $(py3versions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with $py:"
 ; CC=clang CXX=clang++ cmake -DPYTHON_EXECUTABLE=/usr/bin/$py .
 ; cmake --build .
 ; $py -c "import example; assert(example.add(1, 2) == 3)"
 ; done
Depends: clang, cmake, pybind11-dev, python3-all-dev
Restrictions: allow-stderr

Test-Command: set -e
 ; for py in $(py3versions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with $py:"
 ; $py -m pybind11 --includes
 ; done
Depends: python3-all, python3-pybind11

Test-Command: set -e
 ; SRCDIR=$PWD
 ; for py in $(py3versions -rv 2>/dev/null)
 ; do cp -r tests ${AUTOPKGTEST_TMP}/tests-python$py
 ; cd ${AUTOPKGTEST_TMP}/tests-python$py
 ; cmake -DPYVERSION=$py .
 ; make
 ; python$py -m pytest
 ; cd $SRCDIR
 ; done
Depends: python3-all-dev,
 python3-pybind11,
 python3-pytest,
 python3-numpy,
 python3-scipy,
 cmake,
 g++,
 libboost-dev,
 libeigen3-dev

## pybind11 2.9.1

=== debian/changelog ===
pybind11 (2.9.1-2) unstable; urgency=medium

  * Team upload.
  * debian patch python_paths_PR3764.patch applies upstream PR#3764
    to fix python path used by cmake. Closes: #1006615.

 -- Drew Parsons <dparsons@debian.org>  Tue, 15 Mar 2022 20:54:33 +0100

pybind11 (2.9.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Drew Parsons <dparsons@debian.org>  Fri, 11 Feb 2022 11:47:07 +0100

pybind11 (2.9.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
    - applies debian patch drop_lto_on_some_archs.patch

 -- Drew Parsons <dparsons@debian.org>  Wed, 05 Jan 2022 11:35:54 +0100

pybind11 (2.8.1-3) unstable; urgency=medium

  * Team upload.
  * upload pybind11 2.8.1 to unstable

 -- Drew Parsons <dparsons@debian.org>  Sat, 18 Dec 2021 22:47:30 +0100

pybind11 (2.8.1-2) experimental; urgency=medium

  * Team upload.
  * Standards-Version: 4.6.0
  * build command4 debian tests with VERBOSE=1

 -- Drew Parsons <dparsons@debian.org>  Mon, 13 Dec 2021 12:53:18 +0100

pybind11 (2.8.1-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.

 -- Drew Parsons <dparsons@debian.org>  Sun, 07 Nov 2021 22:48:39 +0100

pybind11 (2.7.1-2) unstable; urgency=medium

  * Team upload.
  * [508b902] Add .gitlab-ci.yml
  * [48e392c] Drop LTO on some archs. (Closes: #1000780)

 -- Anton Gladky <gladk@debian.org>  Mon, 13 Dec 2021 19:55:33 +0100

pybind11 (2.7.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Drew Parsons <dparsons@debian.org>  Mon, 16 Aug 2021 02:17:27 +0200

pybind11 (2.7.0-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.

 -- Drew Parsons <dparsons@debian.org>  Fri, 23 Jul 2021 13:42:32 +0200

=== debian/control ===
--- 
+++ 
@@ -21,7 +21,7 @@
                python3-sphinx-rtd-theme <!nodoc>,
                python3-wheel,
                sphinx-common
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/science-team/pybind11
 Vcs-Git: https://salsa.debian.org/science-team/pybind11.git
 Homepage: https://github.com/pybind/pybind11

=== debian/tests/control ===
--- 
+++ 
@@ -36,7 +36,7 @@
  ; do cp -r tests ${AUTOPKGTEST_TMP}/tests-python$py
  ; cd ${AUTOPKGTEST_TMP}/tests-python$py
  ; cmake -DPYVERSION=$py .
- ; make
+ ; make VERBOSE=1
  ; python$py -m pytest
  ; cd $SRCDIR
  ; done

## pybind11 2.10.0

=== debian/changelog ===
pybind11 (2.10.0-2) unstable; urgency=medium

  * Team upload.
  * debian/tests: exclude armel from command2 (clang++). Gives error
    "undefined symbol: __atomic_fetch_add_4" on armel (armhf is fine)

 -- Drew Parsons <dparsons@debian.org>  Wed, 27 Jul 2022 11:42:58 +0200

pybind11 (2.10.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
    - Build-Depends: python3-sphinx-copybutton <!nodoc>
  * update debian patch skip_sphinxcontrib_doc.patch to not use
    html theme furo (not available)
  * Standards-Version: 4.6.1
  * add Restrictions: allow-stderr in debian/tests command 4
    (now makes LTO warnings in stderr)

 -- Drew Parsons <dparsons@debian.org>  Tue, 26 Jul 2022 21:49:52 +0200

pybind11 (2.9.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
    - applies debian patch python_paths_PR3764.patch
  * Build-Depends: pybuild-plugin-pyproject
    to build using pyproject.toml (PEP517)

 -- Drew Parsons <dparsons@debian.org>  Wed, 20 Apr 2022 16:24:53 +0200

=== debian/control ===
--- 
+++ 
@@ -7,6 +7,7 @@
                cmake (>= 3.18~),
                dpkg-dev (>= 1.17.14),
                dh-python,
+               pybuild-plugin-pyproject,
                libboost-dev (>= 1.56) <!nocheck>,
                libeigen3-dev <!nocheck>,
                ninja-build,
@@ -18,10 +19,11 @@
                python3-scipy <!nocheck>,
                python3-setuptools,
                python3-sphinx <!nodoc>,
+               python3-sphinx-copybutton <!nodoc>,
                python3-sphinx-rtd-theme <!nodoc>,
                python3-wheel,
                sphinx-common
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/science-team/pybind11
 Vcs-Git: https://salsa.debian.org/science-team/pybind11.git
 Homepage: https://github.com/pybind/pybind11

## pybind11 2.10.3

=== debian/changelog ===
pybind11 (2.10.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Drew Parsons <dparsons@debian.org>  Mon, 09 Jan 2023 13:29:12 +0100

pybind11 (2.10.2-1) unstable; urgency=medium

  * Team upload.

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable):
    + Build-Depends: Drop versioned constraint on dpkg-dev and libboost-dev.

  [ Drew Parsons ]
  * New upstream release.
  * Standards-Version: 4.6.2

 -- Drew Parsons <dparsons@debian.org>  Fri, 23 Dec 2022 01:43:04 +0100

pybind11 (2.10.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
    - provides pkgconfig file (in pybind11-dev)

 -- Drew Parsons <dparsons@debian.org>  Tue, 08 Nov 2022 14:13:42 +0100

=== debian/control ===
--- 
+++ 
@@ -5,10 +5,9 @@
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                cmake (>= 3.18~),
-               dpkg-dev (>= 1.17.14),
                dh-python,
                pybuild-plugin-pyproject,
-               libboost-dev (>= 1.56) <!nocheck>,
+               libboost-dev <!nocheck>,
                libeigen3-dev <!nocheck>,
                ninja-build,
                python3-all,
@@ -23,7 +22,7 @@
                python3-sphinx-rtd-theme <!nodoc>,
                python3-wheel,
                sphinx-common
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/science-team/pybind11
 Vcs-Git: https://salsa.debian.org/science-team/pybind11.git
 Homepage: https://github.com/pybind/pybind11

## pybind11 2.11.1

=== debian/changelog ===
pybind11 (2.11.1-2) unstable; urgency=medium

  * Team upload.
  * pybind11-dev Depends: libpython3-dev, not Recommends.
    Python.h is #included (via #include chain) by pybind11.h.
  * after dh_clean remove pytest cache files. Closes: #1048150.

 -- Drew Parsons <dparsons@debian.org>  Mon, 13 Nov 2023 13:31:25 +0100

pybind11 (2.11.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Drew Parsons <dparsons@debian.org>  Sun, 23 Jul 2023 04:20:52 +0200

pybind11 (2.10.4-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * pybind11-dev Recommends: libpython3-dev to help ensure Python.h is
    available. Closes: #1032324.

 -- Drew Parsons <dparsons@debian.org>  Mon, 12 Jun 2023 01:43:06 +0200

=== debian/control ===
--- 
+++ 
@@ -31,7 +31,7 @@
 Architecture: all
 Multi-Arch: foreign
 Section: libdevel
-Depends: ${misc:Depends}
+Depends: libpython3-dev, ${misc:Depends}
 Recommends: libeigen3-dev
 Suggests: pybind11-doc <!nodoc>
 Description: seamless operability between C++11 and Python

=== debian/rules ===
--- 
+++ 
@@ -18,6 +18,9 @@
 
 %:
 	dh $@ --with python3,sphinxdoc --buildsystem=cmake
+
+execute_after_dh_clean:
+	rm -rf tests/.pytest_cache
 
 override_dh_auto_clean:
 	dh_auto_clean

## pybind11 2.12.0

=== debian/changelog ===
pybind11 (2.12.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Build-Depends: furo, python3-sphinxcontrib.moderncmakedomain.
    Update debian patch skip_sphinxcontrib_doc.patch.
  * Standards-Version: 4.7.0

 -- Drew Parsons <dparsons@debian.org>  Sat, 25 May 2024 17:08:02 +0200

=== debian/control ===
--- 
+++ 
@@ -17,12 +17,14 @@
                python3-pytest <!nocheck>,
                python3-scipy <!nocheck>,
                python3-setuptools,
+               furo <!nodoc>,
                python3-sphinx <!nodoc>,
                python3-sphinx-copybutton <!nodoc>,
                python3-sphinx-rtd-theme <!nodoc>,
+               python3-sphinxcontrib.moderncmakedomain <!nodoc>,
                python3-wheel,
                sphinx-common
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/science-team/pybind11
 Vcs-Git: https://salsa.debian.org/science-team/pybind11.git
 Homepage: https://github.com/pybind/pybind11

## pybind11 2.13.5

=== debian/changelog ===
pybind11 (2.13.5-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Drew Parsons <dparsons@debian.org>  Sun, 01 Sep 2024 13:14:52 +0200

## pybind11 2.13.6

=== tests/requirements.txt ===
--only-binary=:all:
build~=1.0; python_version>="3.7"
numpy~=1.20.0; python_version=="3.7" and platform_python_implementation=="PyPy"
numpy~=1.23.0; python_version=="3.8" and platform_python_implementation=="PyPy"
numpy~=1.25.0; python_version=="3.9" and platform_python_implementation=='PyPy'
numpy~=1.21.5; platform_python_implementation!="PyPy" and python_version>="3.7" and python_version<"3.10"
numpy~=1.22.2; platform_python_implementation!="PyPy" and python_version=="3.10"
numpy~=1.26.0; platform_python_implementation!="PyPy" and python_version>="3.11" and python_version<"3.13"
pytest~=7.0
pytest-timeout
scipy~=1.5.4; platform_python_implementation!="PyPy" and python_version<"3.10"
scipy~=1.8.0; platform_python_implementation!="PyPy" and python_version=="3.10" and sys_platform!='win32'
scipy~=1.11.1; platform_python_implementation!="PyPy" and python_version>="3.11" and python_version<"3.13" and sys_platform!='win32'

=== tests/test_cmake_build/installed_embed/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

# The `cmake_minimum_required(VERSION 3.5...3.29)` syntax does not work with
# some versions of VS that have a patched CMake 3.11. This forces us to emulate
# the behavior using the following workaround:
if(${CMAKE_VERSION} VERSION_LESS 3.29)
  cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
else()
  cmake_policy(VERSION 3.29)
endif()

project(test_installed_embed CXX)

find_package(pybind11 CONFIG REQUIRED)
message(STATUS "Found pybind11 v${pybind11_VERSION}: ${pybind11_INCLUDE_DIRS}")

add_executable(test_installed_embed ../embed.cpp)
target_link_libraries(test_installed_embed PRIVATE pybind11::embed)
set_target_properties(test_installed_embed PROPERTIES OUTPUT_NAME test_cmake_build)

# Do not treat includes from IMPORTED target as SYSTEM (Python headers in pybind11::embed).
# This may be needed to resolve header conflicts, e.g. between Python release and debug headers.
set_target_properties(test_installed_embed PROPERTIES NO_SYSTEM_FROM_IMPORTED ON)

add_custom_target(
  check_installed_embed
  $<TARGET_FILE:test_installed_embed> ${PROJECT_SOURCE_DIR}/../test.py
  DEPENDS test_installed_embed)

=== debian/changelog ===
pybind11 (2.13.6-2) unstable; urgency=medium

  * Team upload.
  * Sourcefull update for Numpy 2.x transition (Closes: #1094717)

 -- Alexandre Detiste <tchet@debian.org>  Fri, 31 Jan 2025 14:39:46 +0100

pybind11 (2.13.6-1) unstable; urgency=medium

  * d/control: Add myself as uploaders.
  * d/rules: Remove unnecessary get-orig-source target.  
  * New upstream version.
  * d/gbp.conf: change debian-branch to debian/latest to be according to
    DEP-14.

 -- Emmanuel Arias <eamanu@debian.org>  Sun, 22 Sep 2024 11:11:53 -0300

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 Source: pybind11
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
+Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>,
+           Emmanuel Arias <eamanu@debian.org>
 Section: libs
 Priority: optional
 Build-Depends: debhelper-compat (= 13),

=== debian/rules ===
--- 
+++ 
@@ -62,6 +62,3 @@
 	sed "s|src=\"https://img.shields.io/pypi/v/pybind11.svg|src=\"_images/pybind11_pypi.svg|g" -i debian/pybind11-doc/usr/share/doc/pybind11-doc/html/*.html
 	sed "s|src=\"https://img.shields.io/pypi/pyversions/pybind11.svg|src=\"_images/pybind11_pyversions.svg|g" -i debian/pybind11-doc/usr/share/doc/pybind11-doc/html/*.html
 	sed "s|src=\"https://repology.org/badge/latest-versions/python:pybind11.svg|src=\"_images/pybind11_lastest.svg|g" -i debian/pybind11-doc/usr/share/doc/pybind11-doc/html/*.html
-
-get-orig-source:
-	uscan --download-current-version --force-download --no-symlink

## pybind11 3.0.1

=== docs/requirements.txt ===
# This file was autogenerated by uv via the following command:
#    uv pip compile docs/requirements.in -o docs/requirements.txt
alabaster==0.7.16
    # via sphinx
babel==2.14.0
    # via sphinx
beautifulsoup4==4.12.3
    # via furo
breathe==4.35.0
    # via -r requirements.in
certifi==2024.7.4
    # via requests
charset-normalizer==3.3.2
    # via requests
docutils==0.20.1
    # via
    #   breathe
    #   myst-parser
    #   sphinx
furo==2024.1.29
    # via -r requirements.in
idna==3.7
    # via requests
imagesize==1.4.1
    # via sphinx
importlib-metadata==8.7.0
    # via sphinx
jinja2==3.1.6
    # via
    #   myst-parser
    #   sphinx
markdown-it-py==3.0.0
    # via
    #   mdit-py-plugins
    #   myst-parser
markupsafe==2.1.5
    # via jinja2
mdit-py-plugins==0.4.2
    # via myst-parser
mdurl==0.1.2
    # via markdown-it-py
myst-parser==3.0.1
    # via -r requirements.in
packaging==24.0
    # via sphinx
pygments==2.17.2
    # via
    #   furo
    #   sphinx
pyyaml==6.0.2
    # via myst-parser
requests==2.32.4
    # via sphinx
snowballstemmer==2.2.0
    # via sphinx
soupsieve==2.5
    # via beautifulsoup4
sphinx==7.2.6
    # via
    #   -r requirements.in
    #   breathe
    #   furo
    #   myst-parser
    #   sphinx-basic-ng
    #   sphinx-copybutton
    #   sphinxcontrib-moderncmakedomain
    #   sphinxcontrib-svg2pdfconverter
sphinx-basic-ng==1.0.0b2
    # via furo
sphinx-copybutton==0.5.2
    # via -r requirements.in
sphinxcontrib-applehelp==1.0.8
    # via sphinx
sphinxcontrib-devhelp==1.0.6
    # via sphinx
sphinxcontrib-htmlhelp==2.0.5
    # via sphinx
sphinxcontrib-jsmath==1.0.1
    # via sphinx
sphinxcontrib-moderncmakedomain==3.27.0
    # via -r requirements.in
sphinxcontrib-qthelp==1.0.7
    # via sphinx
sphinxcontrib-serializinghtml==1.1.10
    # via sphinx
sphinxcontrib-svg2pdfconverter==1.2.2
    # via -r requirements.in
urllib3==2.5.0
    # via requests
zipp==3.23.0
    # via importlib-metadata

=== tests/requirements.txt ===
--extra-index-url=https://www.graalvm.org/python/wheels
--only-binary=:all:
build>=1
numpy~=1.23.0; python_version=="3.8" and platform_python_implementation=="PyPy"
numpy~=1.25.0; python_version=="3.9" and platform_python_implementation=="PyPy"
numpy~=2.2.0; python_version=="3.10" and platform_python_implementation=="PyPy"
numpy~=1.26.0; platform_python_implementation=="GraalVM" and sys_platform=="linux"
numpy~=1.21.5; platform_python_implementation=="CPython" and python_version>="3.8" and python_version<"3.10"
numpy~=1.22.2; platform_python_implementation=="CPython" and python_version=="3.10"
numpy~=1.26.0; platform_python_implementation=="CPython" and python_version>="3.11" and python_version<"3.13"
numpy~=2.2.0; platform_python_implementation=="CPython" and python_version=="3.13"
pytest>=6
pytest-timeout
scipy~=1.5.4; platform_python_implementation=="CPython" and python_version<"3.10"
scipy~=1.8.0; platform_python_implementation=="CPython" and python_version=="3.10" and sys_platform!="win32"
scipy~=1.11.1; platform_python_implementation=="CPython" and python_version>="3.11" and python_version<"3.13" and sys_platform!="win32"
scipy~=1.15.2; platform_python_implementation=="CPython" and python_version=="3.13" and sys_platform!="win32"
tomlkit

=== tests/pure_cpp/CMakeLists.txt ===
find_package(Catch 2.13.10)

if(CATCH_FOUND)
  message(STATUS "Building pure C++ tests (not depending on Python) using Catch v${CATCH_VERSION}")
else()
  message(STATUS "Catch not detected. Interpreter tests will be skipped. Install Catch headers"
                 " manually or use `cmake -DDOWNLOAD_CATCH=ON` to fetch them automatically.")
  return()
endif()

add_executable(smart_holder_poc_test smart_holder_poc_test.cpp)
pybind11_enable_warnings(smart_holder_poc_test)
target_link_libraries(smart_holder_poc_test PRIVATE pybind11::headers Catch2::Catch2)

add_custom_target(
  test_pure_cpp
  COMMAND "$<TARGET_FILE:smart_holder_poc_test>"
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

add_dependencies(check test_pure_cpp)

=== tests/test_embed/CMakeLists.txt ===
possibly_uninitialized(PYTHON_MODULE_EXTENSION Python_INTERPRETER_ID)

if("${PYTHON_MODULE_EXTENSION}" MATCHES "pypy"
   OR "${Python_INTERPRETER_ID}" STREQUAL "PyPy"
   OR "${PYTHON_MODULE_EXTENSION}" MATCHES "graalpy")
  message(STATUS "Skipping embed test on PyPy or GraalPy")
  add_custom_target(cpptest) # Dummy target on PyPy or GraalPy. Embedding is not supported.
  set(_suppress_unused_variable_warning "${DOWNLOAD_CATCH}")
  return()
endif()

if(TARGET Python::Module AND NOT TARGET Python::Python)
  message(STATUS "Skipping embed test since no embed libs found")
  add_custom_target(cpptest) # Dummy target since embedding is not supported.
  set(_suppress_unused_variable_warning "${DOWNLOAD_CATCH}")
  return()
endif()

find_package(Catch 2.13.10)

if(CATCH_FOUND)
  message(STATUS "Building interpreter tests using Catch v${CATCH_VERSION}")
else()
  message(STATUS "Catch not detected. Interpreter tests will be skipped. Install Catch headers"
                 " manually or use `cmake -DDOWNLOAD_CATCH=ON` to fetch them automatically.")
  return()
endif()

find_package(Threads REQUIRED)

if(PYBIND11_TEST_SMART_HOLDER)
  add_compile_definitions(
    -DPYBIND11_RUN_TESTING_WITH_SMART_HOLDER_AS_DEFAULT_BUT_NEVER_USE_IN_PRODUCTION_PLEASE)
endif()

add_executable(test_embed catch.cpp test_interpreter.cpp test_subinterpreter.cpp)
pybind11_enable_warnings(test_embed)

target_link_libraries(test_embed PRIVATE pybind11::embed Catch2::Catch2 Threads::Threads)

if(NOT CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_CURRENT_BINARY_DIR)
  file(COPY test_interpreter.py test_trampoline.py DESTINATION "${CMAKE_CURRENT_BINARY_DIR}")
endif()

add_custom_target(
  cpptest
  COMMAND "$<TARGET_FILE:test_embed>"
  DEPENDS test_embed
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

pybind11_add_module(external_module THIN_LTO external_module.cpp)
set_target_properties(external_module PROPERTIES LIBRARY_OUTPUT_DIRECTORY
                                                 "${CMAKE_CURRENT_BINARY_DIR}")
foreach(config ${CMAKE_CONFIGURATION_TYPES})
  string(TOUPPER ${config} config)
  set_target_properties(external_module PROPERTIES LIBRARY_OUTPUT_DIRECTORY_${config}
                                                   "${CMAKE_CURRENT_BINARY_DIR}")
endforeach()
add_dependencies(cpptest external_module)

add_dependencies(check cpptest)

=== tests/test_cmake_build/installed_embed/CMakeLists.txt ===
--- 
+++ 
@@ -1,13 +1,4 @@
-cmake_minimum_required(VERSION 3.5)
-
-# The `cmake_minimum_required(VERSION 3.5...3.29)` syntax does not work with
-# some versions of VS that have a patched CMake 3.11. This forces us to emulate
-# the behavior using the following workaround:
-if(${CMAKE_VERSION} VERSION_LESS 3.29)
-  cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
-else()
-  cmake_policy(VERSION 3.29)
-endif()
+cmake_minimum_required(VERSION 3.15...4.0)
 
 project(test_installed_embed CXX)

=== tests/test_cmake_build/installed_function/CMakeLists.txt ===
--- 
+++ 
@@ -1,14 +1,4 @@
-cmake_minimum_required(VERSION 3.4)
-project(test_installed_module CXX)
-
-# The `cmake_minimum_required(VERSION 3.4...3.18)` syntax does not work with
-# some versions of VS that have a patched CMake 3.11. This forces us to emulate
-# the behavior using the following workaround:
-if(${CMAKE_VERSION} VERSION_LESS 3.18)
-  cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
-else()
-  cmake_policy(VERSION 3.18)
-endif()
+cmake_minimum_required(VERSION 3.15...4.0)
 
 project(test_installed_function CXX)
 
@@ -35,4 +25,5 @@
   PYTHONPATH=$<TARGET_FILE_DIR:test_installed_function>
   ${_Python_EXECUTABLE}
   ${PROJECT_SOURCE_DIR}/../test.py
-  ${PROJECT_NAME})
+  ${PROJECT_NAME}
+  DEPENDS test_installed_function)

=== tests/test_cmake_build/subdirectory_embed/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15...4.0)

project(test_subdirectory_embed CXX)

set(PYBIND11_INSTALL
    ON
    CACHE BOOL "")
set(PYBIND11_EXPORT_NAME test_export)

# Allow PYTHON_EXECUTABLE if in FINDPYTHON mode and building pybind11's tests
# (makes transition easier while we support both modes).
if(DEFINED PYTHON_EXECUTABLE AND NOT DEFINED Python_EXECUTABLE)
  set(Python_EXECUTABLE "${PYTHON_EXECUTABLE}")
endif()

add_subdirectory("${pybind11_SOURCE_DIR}" pybind11)

# Test basic target functionality
add_executable(test_subdirectory_embed ../embed.cpp)
target_link_libraries(test_subdirectory_embed PRIVATE pybind11::embed)
set_target_properties(test_subdirectory_embed PROPERTIES OUTPUT_NAME test_cmake_build)

add_custom_target(
  check_subdirectory_embed
  $<TARGET_FILE:test_subdirectory_embed> "${PROJECT_SOURCE_DIR}/../test.py"
  DEPENDS test_subdirectory_embed)

# Test custom export group -- PYBIND11_EXPORT_NAME
add_library(test_embed_lib ../embed.cpp)
target_link_libraries(test_embed_lib PRIVATE pybind11::embed)

install(
  TARGETS test_embed_lib
  EXPORT test_export
  ARCHIVE DESTINATION bin
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION lib)
install(EXPORT test_export DESTINATION lib/cmake/test_export/test_export-Targets.cmake)

=== tests/test_cmake_build/subdirectory_target/CMakeLists.txt ===
--- 
+++ 
@@ -1,15 +1,12 @@
-cmake_minimum_required(VERSION 3.4)
-
-# The `cmake_minimum_required(VERSION 3.4...3.18)` syntax does not work with
-# some versions of VS that have a patched CMake 3.11. This forces us to emulate
-# the behavior using the following workaround:
-if(${CMAKE_VERSION} VERSION_LESS 3.18)
-  cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
-else()
-  cmake_policy(VERSION 3.18)
-endif()
+cmake_minimum_required(VERSION 3.15...4.0)
 
 project(test_subdirectory_target CXX)
+
+# Allow PYTHON_EXECUTABLE if in FINDPYTHON mode and building pybind11's tests
+# (makes transition easier while we support both modes).
+if(DEFINED PYTHON_EXECUTABLE AND NOT DEFINED Python_EXECUTABLE)
+  set(Python_EXECUTABLE "${PYTHON_EXECUTABLE}")
+endif()
 
 add_subdirectory("${pybind11_SOURCE_DIR}" pybind11)
 
@@ -37,4 +34,5 @@
   PYTHONPATH=$<TARGET_FILE_DIR:test_subdirectory_target>
   ${_Python_EXECUTABLE}
   ${PROJECT_SOURCE_DIR}/../test.py
-  ${PROJECT_NAME})
+  ${PROJECT_NAME}
+  DEPENDS test_subdirectory_target)

=== debian/changelog ===
pybind11 (3.0.1-2) unstable; urgency=medium

  * Team upload.
  * d/control: Drop <!nocheck> from python3-dev. Closes: #1116840.

 -- Santiago Vila <sanvila@debian.org>  Wed, 08 Oct 2025 20:30:00 +0200

pybind11 (3.0.1-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.7.2 (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Build-Depends: s/dh-python/dh-sequence-python3/ (routine-update)
  * Remove obsolete field Name from debian/upstream/metadata
    (already present in machine-readable debian/copyright).
  * d/patches: Update patches according to new upstream release.
  * d/control: Use python3-scikit-build-core instead of python3-setuptools.
    - Add python3-myst-parser as Build Dependency.
  * d/rules: Install changelog.md instead of changelog.rst.

 -- Emmanuel Arias <eamanu@debian.org>  Fri, 26 Sep 2025 17:12:35 -0300

=== debian/control ===
Source: pybind11
Standards-Version: 4.7.2
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Ghislain Antony Vaillant <ghisvail@gmail.com>,
 Emmanuel Arias <eamanu@debian.org>,
Section: libs
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 dh-sequence-python3,
 pybuild-plugin-pyproject,
 libboost-dev <!nocheck>,
 libeigen3-dev <!nocheck>,
 ninja-build,
 python3-all,
 python3-breathe <!nodoc>,
 python3-dev,
 python3-numpy <!nocheck>,
 python3-pytest <!nocheck>,
 python3-scipy <!nocheck>,
 furo <!nodoc>,
 python3-scikit-build-core,
 python3-myst-parser,
 python3-sphinx <!nodoc>,
 python3-sphinx-copybutton <!nodoc>,
 python3-sphinx-rtd-theme <!nodoc>,
 python3-sphinxcontrib.moderncmakedomain <!nodoc>,
 python3-wheel,
 sphinx-common,
Vcs-Browser: https://salsa.debian.org/science-team/pybind11
Vcs-Git: https://salsa.debian.org/science-team/pybind11.git
Homepage: https://github.com/pybind/pybind11

Package: pybind11-dev
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends:
 libpython3-dev,
 ${misc:Depends},
Recommends:
 libeigen3-dev,
Suggests:
 pybind11-doc <!nodoc>,
Description: seamless operability between C++11 and Python
 pybind11 is a lightweight header library that exposes C++ types in
 Python and vice versa, mainly to create Python bindings of existing C++
 code. Its goals and syntax are similar to the excellent Boost.Python
 library by David Abrahams: to minimize boilerplate code in traditional
 extension modules by inferring type information using compile-time
 introspection.
 .
 This package provides the header-only library.

Package: pybind11-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
Built-Using:
 ${sphinxdoc:Built-Using},
Description: documentation for pybind11
 pybind11 is a lightweight header library that exposes C++ types in
 Python and vice versa, mainly to create Python bindings of existing C++
 code. Its goals and syntax are similar to the excellent Boost.Python
 library by David Abrahams: to minimize boilerplate code in traditional
 extension modules by inferring type information using compile-time
 introspection.
 .
 This package provides the documentation.
Build-Profiles: <!nodoc>

Package: python3-pybind11
Architecture: all
Multi-Arch: foreign
Section: python
Depends:
 ${misc:Depends},
 ${python3:Depends},
 pybind11-dev (= ${binary:Version}),
Recommends:
 python3-numpy,
Description: pybind11 helper module for Python 3
 pybind11 is a lightweight header library that exposes C++ types in
 Python and vice versa, mainly to create Python bindings of existing C++
 code. Its goals and syntax are similar to the excellent Boost.Python
 library by David Abrahams: to minimize boilerplate code in traditional
 extension modules by inferring type information using compile-time
 introspection.
 .
 This package provides pybind11 for Python 3.

=== debian/tests/control ===
--- 
+++ 
@@ -20,6 +20,7 @@
  ; $py -c "import example; assert(example.add(1, 2) == 3)"
  ; done
 Depends: clang, cmake, pybind11-dev, python3-all-dev
+Architecture: alpha amd64 arm64 armhf hppa hurd-i386 i386 ia64 kfreebsd-amd64 kfreebsd-i386 m68k mips mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sh4 sparc64 x32
 Restrictions: allow-stderr
 
 Test-Command: set -e
@@ -49,3 +50,4 @@
  g++,
  libboost-dev,
  libeigen3-dev
+Restrictions: allow-stderr

=== debian/watch ===
version=4
opts=uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/,\
  filenamemangle=s/.+\/v?@ANY_VERSION@\.tar\.gz/pybind11-$1\.tar\.gz/ \
  https://github.com/pybind/pybind11/tags .*/v?@ANY_VERSION@\.tar\.gz

## pybind11 generics-1.0.3

=== CMakeLists.txt ===

# Version 3.15 required because of FindPython module.
cmake_minimum_required(VERSION 3.15)

project(pybind11_generics)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# set(CMAKE_VERBOSE_MAKEFILE ON)

# set compile options
add_compile_options(
  "-fmax-errors=2" "-Wall" "-pedantic"
  "$<$<CONFIG:DEBUG>:-fno-omit-frame-pointer>"
)

# set optimzation level for release
set(CMAKE_CXX_FLAGS_RELEASE "-O3")
# generate compilation commands file for emacs
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
# prefer pthreads
set(THREADS_PREFER_PTHREAD_FLAG ON)

# make sure linker raise errors if shared library has undefined symbols
# this makes it a lot easier to debug
set(CMAKE_SHARED_LINKER_FLAGS "-Wl,--no-undefined")
# add rpaths to the final install executable
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

# Include pybind11
add_subdirectory(pybind11)

# Define pybind11_generics interface library
add_library(pybind11_generics INTERFACE)

target_link_libraries(pybind11_generics
  INTERFACE
  pybind11::module
  )

target_include_directories(pybind11_generics
  INTERFACE
  ${CMAKE_CURRENT_SOURCE_DIR}/include
  )

## pybind11 geobuf-0.1.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(geobuf)

set(CUBAO_INCLUDE ${PROJECT_SOURCE_DIR}/headers/include)
include(${CUBAO_INCLUDE}/utils.cmake)
# set(CMAKE_BUILD_TYPE Debug)

activate_common_configuration()
auto_build_type_and_compile_flags()
configure_output_directories()

if(CMAKE_SYSTEM_NAME STREQUAL "Windows")
    set(CUBAO_USE_DUMMY_VERSION_H "True")
endif()
configure_version_h()

# MISC
add_definitions(-D_CRT_SECURE_NO_WARNINGS)

set(CMAKE_CXX_STANDARD 17)
include_directories(${PROJECT_BINARY_DIR} ${PROJECT_SOURCE_DIR}/headers/include ${PROJECT_SOURCE_DIR}/src)

option(BUILD_SHARED_LIBS "Build shared library." OFF)
set(HEADER_ROOT "${PROJECT_SOURCE_DIR}/src/${PROJECT_NAME}")
file(GLOB_RECURSE HEADERS src/**/*.hpp)
file(GLOB_RECURSE SOURCES src/**/*.cpp)
add_library(${PROJECT_NAME} ${SOURCES} ${HEADERS})
target_link_libraries(${PROJECT_NAME} ${CONAN_LIBS})
set_target_properties(${PROJECT_NAME} PROPERTIES CXX_VISIBILITY_PRESET "hidden")
print_all_linked_libraries(${PROJECT_NAME})
install(
    TARGETS ${PROJECT_NAME}
    LIBRARY DESTINATION lib
    ARCHIVE DESTINATION lib)
foreach(file ${HEADERS})
    get_filename_component(dir ${file} DIRECTORY)
    string(
        REGEX
        REPLACE "${HEADER_ROOT}"
                ""
                dir
                ${dir})
    install(FILES ${file} DESTINATION "include/${PROJECT_NAME}/${dir}")
endforeach()

add_executable(pbf_decoder src/geobuf/pbf_decoder.cpp)
target_compile_definitions(pbf_decoder PUBLIC -DPBF_DECODER_ENABLE_MAIN)
install(TARGETS pbf_decoder RUNTIME DESTINATION bin)

option(BUILD_EXAMPLES "Build examples." ON)
if(BUILD_EXAMPLES)
    file(GLOB SRCS examples/*.cpp)
    foreach(src ${SRCS})
        string(
            REGEX
            REPLACE "(^.*/|.cpp$)"
                    ""
                    exe
                    ${src})
        add_executable(${exe} ${src})
        target_link_libraries(${exe} ${PROJECT_NAME})
        install(TARGETS ${exe} RUNTIME DESTINATION bin)
    endforeach(src)
endif()

option(BUILD_TESTS "Build tests." ON)
if(BUILD_TESTS)
    file(GLOB SRCS tests/test_*.cpp)
    foreach(src ${SRCS})
        string(
            REGEX
            REPLACE "(^.*/|.cpp$)"
                    ""
                    exe
                    ${src})
        add_executable(${exe} ${src})
        target_link_libraries(${exe} ${PROJECT_NAME})
        install(TARGETS ${exe} RUNTIME DESTINATION bin)
    endforeach(src)
endif()
add_custom_target(test_all COMMAND make -C .. test_all)

# print_include_directories()

# print_all_variables()

set(PYBIND11_CPP_STANDARD -std=c++17)
add_subdirectory(pybind11)
pybind11_add_module(
    _pybind11_geobuf
    src/main.cpp
    src/pybind11_rapidjson.cpp
    src/pybind11_geojson.cpp)
target_include_directories(_pybind11_geobuf PRIVATE ${HEADER_ROOT})
target_link_libraries(_pybind11_geobuf PRIVATE ${PROJECT_NAME})
target_compile_definitions(_pybind11_geobuf PRIVATE VERSION_INFO=${PYBIND11_GEOBUF_VERSION_INFO})
